/*
 * Created on Oct 18, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package compilation;

import interpretation_jjc.*;

import java.util.Vector;
import asa.*;

/**
 * @author vbonnet
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Compilateur implements ParserVisitor {
	//vecteur contenant le jajacode
	private Vector jajacode;
	
	//retient la valeur de k des entetes "new(a,entier,var,k)"
	private int k;
	
	//Constructeur : cree le vecteur et initialise k a 1
	public Compilateur(){
		jajacode=new Vector();
		k=1;
	}
	
	//Retourne le Vecteur contenant le jajacode
	public Vector getJajacode(){
		return jajacode;
	}
	
	//Lance la compilation rempli le Vector jajacode cree dans le constructeur
	public void compilation(SimpleNode node){
		node.jjtAccept(this,null);
	}
	
	
	//la fonction toString() retourne un String contenant le jajacode
	public String toString() {
		String res="";
		for (int i = 0; i < jajacode.size(); i++) {
		    res+=(i+1)+" : "+jajacode.get(i).toString()+System.getProperty("line.separator");
		}
		return res;
	}
	
	//La fonction print() permet d'afficher le contenu de vecteur "jajacode"
	public void print() {
		for (int i = 0; i < jajacode.size(); i++) {
		    System.out.println((i+1)+" : "+jajacode.get(i));
		}
	}
	
	public Object visit(SimpleNode node, Object data){
		return null;
	}
	public Object visit(ASTanalyse node, Object data){
		node.jjtGetChild(0).jjtAccept(this,data);
		return null;
	}
	
	
/************************************************************
* Dï¿½clarations										  		*
************************************************************/
	
	//[cclasse]
	public Object visit(ASTclasse node, Object data){
		//init
		jajacode.addElement(new JJCinit());
		//pdss
		node.jjtGetChild(1).jjtAccept(this,data);
		//pmma
		node.jjtGetChild(2).jjtAccept(this,data);
		//prdss
		node.jjtGetChild(1).jjtAccept(this,"retrait");
		//pop
		jajacode.addElement(new JJCpop());
		//jcstop
		jajacode.addElement(new JJCjcstop());
		return null;
	}
	
	//[cdecls]
	public Object visit(ASTdecls node, Object data){
		//pds
		node.jjtGetChild(0).jjtAccept(this,data);
		//pdss
		node.jjtGetChild(1).jjtAccept(this,data);
		return null;
	}
	
	//[cvars]
	public Object visit(ASTvars node, Object data){
		//pdv
		node.jjtGetChild(0).jjtAccept(this,data);
		//pdvs
		node.jjtGetChild(1).jjtAccept(this,data);
		return null;
	}
	
	//[cvar] et [crvar]
	public Object visit(ASTvar node, Object data){
		if((String)data !="retrait"){
			String ident=node.jjtGetChild(1).toString();
			String type=node.jjtGetChild(0).toString();
			//pe
			node.jjtGetChild(2).jjtAccept(this,data);
			//new(i,t,var,0)
			jajacode.addElement(new JJCnewV(ident,type,0));
		}else{
			//swap
			jajacode.addElement(new JJCswap());
			//pop
			jajacode.addElement(new JJCpop());
		}
		return null;
	}
	
	//[cvnil]
	public Object visit(ASTvnil node, Object data){
		return null;
	}
	
	//[ccst] et [crcst]
	public Object visit(ASTcst node, Object data){
		if((String)data !="retrait"){
			String ident=node.jjtGetChild(1).toString();
			String type=node.jjtGetChild(0).toString();
			//pe
			node.jjtGetChild(2).jjtAccept(this,data);
			//new(i,t,cst,0)
			jajacode.addElement(new JJCnewC(ident,type,0));
		}else{
			//swap
			jajacode.addElement(new JJCswap());
			//pop
			jajacode.addElement(new JJCpop());
		}
		return null;
	}
	
	//[ctableau]
	public Object visit(ASTtableau node, Object data){
		if((String)data !="retrait"){
			//pe
			node.jjtGetChild(2).jjtAccept(this,data);
			//newarray(i,t)
			String i=node.jjtGetChild(1).toString();
			String t=node.jjtGetChild(0).toString();
			jajacode.addElement(new JJCnewarray(i,t));
		}else{
			//swap
			jajacode.addElement(new JJCswap());
			//pop
			jajacode.addElement(new JJCpop());
		}
		return null;
	}
	
	//[centetes]
	public Object visit(ASTentetes node, Object data){
		//pen
		node.jjtGetChild(0).jjtAccept(this,data);
		//pens
		node.jjtGetChild(1).jjtAccept(this,data);
		return null;
	}
	
	//[centete]
	public Object visit(ASTentete node, Object data){
		String ident=node.jjtGetChild(1).toString();
		String type=node.jjtGetChild(0).toString();
		//new(i,t,var,k) k sera modifiï¿½ dans methode
		jajacode.addElement(new JJCnewV(ident,type,-1));
		//incrementation de k
		k++;
		return null;
	}
	
	//[cmain]
	public Object visit(ASTmain node, Object data){
		//pdvs
		node.jjtGetChild(0).jjtAccept(this,data);
		//piss
		node.jjtGetChild(1).jjtAccept(this,data);
		//push(0)
		jajacode.addElement(new JJCpush(Integer.toString(0)));
		//prdvs
		node.jjtGetChild(0).jjtAccept(this,"retrait");
		return null;
	}
	
	//[cmethode] et [crmethode]
	public Object visit(ASTmethode node, Object data){
		if((String)data !="retrait"){
			//push(n+3)
			jajacode.addElement(new JJCpush(Integer.toString(jajacode.size()+4)));
			//new(i,t,meth,0)
			String i=node.jjtGetChild(1).toString();
			String t=node.jjtGetChild(0).toString();
			jajacode.addElement(new JJCnewM(i,t,0));
			//goto(n+nens+ndvs+niss+nrdvs+5)
			int addressGoto=jajacode.size();
			jajacode.addElement("goto(");
			//pens
			node.jjtGetChild(2).jjtAccept(this,data);
			//modification ordre des entetes		
			for (int c=1; c<k; c++) {
				((JJCnewV)jajacode.get(jajacode.size()-c)).setIndice(c);
			}
			//reinitialisation de k
			k=1;
			//pdvs
			node.jjtGetChild(3).jjtAccept(this,data);
			//piss
			node.jjtGetChild(4).jjtAccept(this,data);
			//si CMethodeR
			if (node.jjtGetChild(0).toString().equals("rien")) {
				// push(0)
				jajacode.addElement(new JJCpush("0"));
			}
			//prdvs
			node.jjtGetChild(3).jjtAccept(this,"retrait");
			//swap
			jajacode.addElement(new JJCswap());
			//return
			jajacode.addElement(new JJCreturn());
			
			//valeur du goto
			jajacode.setElementAt(new JJCgoto(jajacode.size()+1),addressGoto);
		}else{
			//swap
			jajacode.addElement(new JJCswap());
			//pop
			jajacode.addElement(new JJCpop());
		}
		return null;
	}
	
	
/************************************************************
* Instructions										  		*
************************************************************/
	
	//[cinstrs]
	public Object visit(ASTinstrs node, Object data){
		//pis
		node.jjtGetChild(0).jjtAccept(this,data);
		//piss
		node.jjtGetChild(1).jjtAccept(this,data);		
		return null;
	}
	
	//[csomme] et [csommeT]
	public Object visit(ASTsomme node, Object data){
		if(node.jjtGetChild(0) instanceof ASTident) {
		    // csomme : somme(ident(i), e) => {pe + inc(i)}

		    String ident = (String) node.jjtGetChild(0).toString();
		    // pe
		    node.jjtGetChild(1).jjtAccept(this,data);
		    //inc(i)
		    jajacode.addElement(new JJCinc(ident));
		}
		else {
		    // csommeT : somme(tab(ident(i), e1), e) => {pe1 + pe + ainc(i)}

		    String ident = node.jjtGetChild(0).jjtGetChild(0).toString();
		    //pe1
		    node.jjtGetChild(0).jjtGetChild(1).jjtAccept(this,data);    
		    //pe
		    node.jjtGetChild(1).jjtAccept(this,data);
		    //ainc(i)
		    jajacode.addElement(new JJCainc(ident));
		}
		return null;
	}
	
	//[cinc] et [cincT]
	public Object visit(ASTincrement node, Object data){
		if(node.jjtGetChild(0) instanceof ASTident) {
		    // cinc : increment(ident(i)) => {push(1) + inc(i)}

		    String ident = node.jjtGetChild(0).toString();
		    //push(1)
		    jajacode.addElement(new JJCpush(Integer.toString(1)));
		    //inc(i)
		    jajacode.addElement(new JJCinc(ident));
		}
		else {
		    // cincT : increment(tab(ident(i), e)) =>  {pe + push(1) + ainc(i)}
		    
		    String ident = node.jjtGetChild(0).jjtGetChild(0).toString();
		    //pe
		    node.jjtGetChild(0).jjtGetChild(1).jjtAccept(this,data);
		    // push(1)
		    jajacode.addElement(new JJCpush(Integer.toString(1)));
		    // ainc(i)
		    jajacode.addElement(new JJCainc(ident));
		}
		return null;
	}
	
	//[caffect] et [caffecteT]
	public Object visit(ASTaffectation node, Object data){
		if(node.jjtGetChild(0) instanceof ASTident) {
		    // caffecte : affecte(ident(i), e) => {pe + store(i)}

		    String ident = node.jjtGetChild(0).toString();
		    //pe
		    node.jjtGetChild(1).jjtAccept(this,data);
		    //store(i)
		    jajacode.addElement(new JJCstore(ident));
		}
		else {
		    // caffecteT : affecte(tab(ident(i), e1), e) =>

		    String ident = node.jjtGetChild(0).jjtGetChild(0).toString();
		    //pe1
		    node.jjtGetChild(0).jjtGetChild(1).jjtAccept(this,data);
		    // pe
		    node.jjtGetChild(1).jjtAccept(this,data);
		    // astore(i)
		    jajacode.addElement(new JJCastore(ident));
		}
			
		return null;
	}
	
	//[cappelE]
	public Object visit(ASTappelE node, Object data){
		String ident = (String) node.jjtGetChild(0).toString();
		//plexp
		node.jjtGetChild(1).jjtAccept(this,data);
		//invoke(i)
		jajacode.addElement(new JJCinvoke(ident));
		//prlexp
		node.jjtGetChild(1).jjtAccept(this, "retrait");
		return null;
	}
	
	//[cappelI]
	public Object visit(ASTappelI node, Object data){
		String ident = (String) node.jjtGetChild(0).toString();
		//plexp
		node.jjtGetChild(1).jjtAccept(this,data);
		//invoke(i)
		jajacode.addElement(new JJCinvoke(ident));	
		//prlexp
		node.jjtGetChild(1).jjtAccept(this, "retrait");
		//pop
		jajacode.addElement(new JJCpop());
		return null;
	}
	
	//[cretour]
	public Object visit(ASTretour node, Object data){
		//pe
		node.jjtGetChild(0).jjtAccept(this,data);
		return null;
	}
	
	//[csi]
	public Object visit(ASTsi node, Object data){
		int adressTmp;
		// pe
		node.jjtGetChild(0).jjtAccept(this,data);
		//if temporaire
		adressTmp = jajacode.size();
		jajacode.addElement("if()");

		//piss1
		node.jjtGetChild(2).jjtAccept(this,data);
		//if(n + ne + niss1 + 2)
		int n = jajacode.size(); 
		jajacode.set(adressTmp, new JJCif(n + 2));
		adressTmp = jajacode.size();
		jajacode.addElement("goto()");
		//piss
		node.jjtGetChild(1).jjtAccept(this,data);

		//goto(n + ne + niss1 + niss + 2
		jajacode.set(adressTmp, new JJCgoto(jajacode.size()+1));
		return null;
	}
	
	//[ctantque]
	public Object visit(ASTtantque node, Object data){
		int addressGoto = jajacode.size()+1;
		//pe
		node.jjtGetChild(0).jjtAccept(this,data);
		//not
		jajacode.addElement(new JJCTnot());
		//if(n + ne + niss + 3)
		int fi = jajacode.size();
		jajacode.addElement(new JJCnop());
		//iss
		node.jjtGetChild(1).jjtAccept(this,data);
		//retour goto
		jajacode.addElement(new JJCgoto(addressGoto));
		//valeur du if
		jajacode.set(fi, new JJCif(jajacode.size()+1));
		return null;
	}
	
	
/************************************************************
* Expressions										  		*
************************************************************/
	
	//[ctab]
	public Object visit(ASTtab node, Object data){
		if((String)data !="retrait"){
			String ident=node.jjtGetChild(0).toString();
			//pe
			node.jjtGetChild(1).jjtAccept(this,data);
			//aload(i)
			jajacode.addElement(new JJCaload(ident));
		}else{
			//swap
			jajacode.addElement(new JJCswap());
			//pop
			jajacode.addElement(new JJCpop());
		}
		return null;
	}
	
	//[cident]
	public Object visit(ASTident node, Object data){
		//load(i)
		jajacode.addElement(new JJCload(node.toString()));
		return null;
	}
	
	//[cnbre]
	public Object visit(ASTnbre node, Object data){
		//push(i)
		jajacode.addElement(new JJCpush(node.getInt()+""));
		return null;
	}
	
	//[cvrai]
	public Object visit(ASTvrai node, Object data){
		// push(jcvrai)
		jajacode.addElement(new JJCpush("true"));
		return null;
	}
	
	//[cfaux]
	public Object visit(ASTfaux node, Object data){
		//push(jcfaux)
		jajacode.addElement(new JJCpush("false"));
		return null;
	}
	
	//[clexp]
	public Object visit(ASTlistexp node, Object data){
		if((String) data != "retrait") {
			//plexp
		    node.jjtGetChild(1).jjtAccept(this,data);
		    //pe
		    node.jjtGetChild(0).jjtAccept(this,data);
		}
		else {
			//swap
		    jajacode.addElement(new JJCswap());
		    //pop
		    jajacode.addElement(new JJCpop());
		    //prlexp
		    node.jjtGetChild(1).jjtAccept(this,data);
		}
		return null;
	}
	
	
	//[cop1] et [cop2]
	public Object visit(ASTnon node, Object data){
		//pe
		node.jjtGetChild(0).jjtAccept(this,data);
		// neg
		jajacode.addElement(new JJCTnot());
		return null;
	}
	public Object visit(ASTet node, Object data){
		//e1
		node.jjtGetChild(0).jjtAccept(this,data);
		//e
		node.jjtGetChild(1).jjtAccept(this,data);
		// operateur
		jajacode.addElement(new JJCTand());
		return null;
	}
	public Object visit(ASTou node, Object data){
		//e1
		node.jjtGetChild(0).jjtAccept(this,data);
		//e
		node.jjtGetChild(1).jjtAccept(this,data);
		//operateur
		jajacode.addElement(new JJCTor());
		return null;
	}
	public Object visit(ASTmoins node, Object data){
		//e
		node.jjtGetChild(0).jjtAccept(this,data);
		//operateur
		jajacode.addElement(new JJCTneg());
		return null;
	}
	public Object visit(ASTegal node, Object data){
		//e1
		node.jjtGetChild(0).jjtAccept(this,data);
		//e
		node.jjtGetChild(1).jjtAccept(this,data);
		//operateur
		jajacode.addElement(new JJCTcmp());
		return null;
	}
	public Object visit(ASTpgq node, Object data){
		//e1
		node.jjtGetChild(0).jjtAccept(this,data);
		//e
		node.jjtGetChild(1).jjtAccept(this,data);
		//operateur
		jajacode.addElement(new JJCTsup());
		return null;
	}
	public Object visit(ASTplus node, Object data){
		//e1
		node.jjtGetChild(0).jjtAccept(this,data);
		//e
		node.jjtGetChild(1).jjtAccept(this,data);
		//operateur
		jajacode.addElement(new JJCTadd());
		return null;
	}
	public Object visit(ASTsoustrac node, Object data){
		//e1
		node.jjtGetChild(0).jjtAccept(this,data);
		//e
		node.jjtGetChild(1).jjtAccept(this,data);
		//operateur
		jajacode.addElement(new JJCTsub());
		return null;
	}
	public Object visit(ASTmulti node, Object data){
		//e1
		node.jjtGetChild(0).jjtAccept(this,data);
		//e
		node.jjtGetChild(1).jjtAccept(this,data);
		// operateur
		jajacode.addElement(new JJCTmul());
		return null;
	}
	public Object visit(ASTdiv node, Object data){
		//e1
		node.jjtGetChild(0).jjtAccept(this,data);
		//e
		node.jjtGetChild(1).jjtAccept(this,data);
		//operateur
		jajacode.addElement(new JJCTdiv());
		return null;
	}
	public Object visit(ASTomega node, Object data){
		//push(w)
		jajacode.addElement(new JJCpush(0+""));
		return null;
	}
	
	//[enil]
	public Object visit(ASTrien node, Object data){
		return null;
	}
	
	
	public Object visit(ASTentier node, Object data){
		
		return null;
	}
	public Object visit(ASTbooleen node, Object data){
		
		return null;
	}
	
	public Object visit(ASTenil node, Object data){
		
		return null;
	}
	public Object visit(ASTinil node, Object data){
		
		return null;
	}
	public Object visit(ASTexnil node, Object data){
		
		return null;
	}
}
