package ihm;


import java.awt.*;
import java.awt.event.*;
import java.beans.PropertyVetoException;
import java.io.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.tree.*;

import interpretation_jjc.*;
import interpretation_mjj.*;
import compilation.*;
import ControleDeType.*;
import asa.*;


public class FenetrePrincipale extends JFrame {

	JMenuItem itemNouveau, itemOuvrir, itemEnregistrer, itemEnregistrerSous, itemQuitter;
	JMenuItem itemCompiler;
	JMenuItem itemMjj;
	JMenuItem itemJjcPasAPas;
	JMenuItem itemJjcPtArret;
	JMenuItem itemFenetreMjj, itemFenetreJjc, itemFenetreInterpretation, itemFenetreMessage, itemArbreAsa;
	JMenuBar menuBar;
	JMenu menuFichier = new JMenu("Fichier",true);
	JMenu menuCompilation = new JMenu("Compilation",true);
	JMenu menuMjj = new JMenu("MiniJaja", true);
	JMenu menuJjc = new JMenu("JajaCode", true);
	JMenu menuAffichage = new JMenu("Affichage", true);
	JToolBar toolBar;
	JButton bMjj, bComp, bJjc1, bJjc2;
	JToggleButton bCont, bTas;
	FenetreMjj fenMjj;
	FenetreJjc fenJjc;
	FenetreInterpretation fenInterpretation;
	FenetreMessage fenMessage;
	FenetreAsa fenAsa;
	JPanel panelGlobal;
	JPanel panelBureau;
	JPanel panelMjj;
	JPanel panelCompilation;
	JPanel panelInterpretation;
	JTabbedPane onglet;
	GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints gbc = new GridBagConstraints();
	File cheminFichier = null;
	String nomFichier = "Sans titre";
	Parser parser = null;
	SimpleNode parseTree = null;	
	SimpleNode nodeDepart;
	interpretationMiniJaja minijaja = null;
	Compilateur compilateur = null;
	InterpreteurJJC jajacode = null;
	Controle controleDeType;
	boolean fichierEnregistre = true;
	boolean fichierSansTitre = true;
	int largeur, hauteur;
	boolean parsingOk;
	
	public FenetrePrincipale() {
		super();

		configurationFenetre();
		
		creationMenu();
		creationPanelGlobal();
		creationToolBar();
		creationPanelBureau();
		creationFenetreMjj();
		creationFenetreJjc();
		creationFenetreInterpretation();
		creationFenetreMessage();
		creationFenetreAsa();	
	}

	public void configurationFenetre() {
		
		Dimension tailleEcran = Toolkit.getDefaultToolkit().getScreenSize();
		this.setTitle("Compilateur MiniJaja");
		int largeurEcran = tailleEcran.width;
		int hauteurEcran = tailleEcran.height;
		largeur = largeurEcran-100;
		hauteur = hauteurEcran-100;
		this.setSize(largeur, hauteur);
		this.setExtendedState(JFrame.MAXIMIZED_BOTH);
		
		
		closeAppli();
		
		//creationPanelMjj();
		//creationPanelCompilation();
		//creationPanelInterpretation();
	}
	
	public void creationPanelGlobal() {
		
		panelGlobal = new JPanel(new BorderLayout());
		this.getContentPane().add(panelGlobal);
		
	}
	
	public void creationPanelBureau() {
		
		panelBureau = new JPanel(gridbag);
		panelGlobal.add(panelBureau,BorderLayout.CENTER);
		
	}
	
	/*public void creationPanelMjj() {
		
		panelMjj = new JPanel();
		panelMjj.setBackground(Color.BLUE);
		panelBureau.add(fenMjj);
		
	}
	
	public void creationPanelCompilation() {
		
		panelCompilation = new JPanel();
		panelCompilation.setBackground(Color.GREEN);
		panelBureau.add(panelCompilation);
		
	}
	
	public void creationPanelInterpretation() {
		
		panelInterpretation = new JPanel();
		panelInterpretation.setBackground(Color.RED);
		panelBureau.add(panelInterpretation);
		
	}*/
	
	private void creationFenetreMjj() {

		fenMjj = new FenetreMjj();
		gbc.gridx = 0;			// numro de colonne
		gbc.gridy = 0;			// numro de ligne
		gbc.gridwidth = 1;		// nombre de colonnes couvertes
		gbc.gridheight = 1;		// nombre de lignes couvertes
		gbc.weightx = 33;		// proportion de ligne occupe
		gbc.weighty = 70;		// proportion de colonne occupe
		gbc.fill = GridBagConstraints.BOTH;	// tirement du composant
		gridbag.setConstraints(fenMjj, gbc);
		panelBureau.add(fenMjj);
		
		ecouteurMjj();
		
	}
		
	private void creationFenetreJjc() {
		
		fenJjc = new FenetreJjc();
		gbc.gridx = 1;			// numro de colonne
		gbc.gridy = 0;			// numro de ligne
		gbc.gridwidth = 1;		// nombre de colonnes couvertes
		gbc.gridheight = 1;		// nombre de lignes couvertes
		gbc.weightx = 33;		// proportion de ligne occupe
		gbc.weighty = 70;		// proportion de colonne occupe
		gbc.fill = GridBagConstraints.BOTH;	// tirement du composant
		gridbag.setConstraints(fenJjc, gbc);
		panelBureau.add(fenJjc);
		
	}
	
	private void creationFenetreMessage() {

		fenMessage = new FenetreMessage();
		gbc.gridx = 0;			// numro de colonne
		gbc.gridy = 1;			// numro de ligne
		gbc.gridwidth = 2;		// nombre de colonnes couvertes
		gbc.gridheight = 1;		// nombre de lignes couvertes
		gbc.weightx = 66;		// proportion de ligne occupe
		gbc.weighty = 30;		// proportion de colonne occupe
		gbc.fill = GridBagConstraints.BOTH;	// tirement du composant
		gridbag.setConstraints(fenMessage, gbc);
		panelBureau.add(fenMessage);
		
	}
	
	private void creationFenetreAsa() {

		fenAsa = new FenetreAsa();
		gbc.gridx = 2;			// numro de colonne
		gbc.gridy = 1;			// numro de ligne
		gbc.gridwidth = 1;		// nombre de colonnes couvertes
		gbc.gridheight = 1;		// nombre de lignes couvertes
		gbc.weightx = 34;		// proportion de ligne occupe
		gbc.weighty = 30;		// proportion de colonne occupe
		gbc.fill = GridBagConstraints.BOTH;	// tirement du composant
		gridbag.setConstraints(fenAsa, gbc);
		panelBureau.add(fenAsa);
		
	}
	
	private void creationFenetreInterpretation() {

		fenInterpretation = new FenetreInterpretation();
		gbc.gridx = 2;			// numro de colonne
		gbc.gridy = 0;			// numro de ligne
		gbc.gridwidth = 1;		// nombre de colonnes couvertes
		gbc.gridheight = 1;		// nombre de lignes couvertes
		gbc.weightx = 34;		// proportion de ligne occupe
		gbc.weighty = 70;		// proportion de colonne occupe
		gbc.fill = GridBagConstraints.BOTH;	// tirement du composant
		gridbag.setConstraints(fenInterpretation, gbc);
		panelBureau.add(fenInterpretation);
		
	}
	
	public void ecouteurMjj() {
		this.fenMjj.zoneEcriture.addKeyListener(new KeyListener() {
			String txtMjjAvantModif = "";
			String txtMjjApresModif = "";
			public void keyTyped(KeyEvent arg0) {}

			public void keyPressed(KeyEvent arg0) {
				txtMjjAvantModif = fenMjj.getTxtMjj();
				//System.out.println("Avant = " + fenMjj.getTxtMjj());
			}

			public void keyReleased(KeyEvent arg0) {
				txtMjjApresModif = fenMjj.getTxtMjj();
				//System.out.println("Apres = " + fenMjj.getTxtMjj());
				
				if ((txtMjjAvantModif != txtMjjApresModif) && fichierEnregistre) {
					fenMjj.setTitle(fenMjj.obtenirNomFichier() + " *");
					fichierEnregistre = false;
					if (!fichierSansTitre)
						itemEnregistrer.setEnabled(true);
				}
				
			}
			
		});
	}
	
	public void closeAppli() {
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				   boolean verif = verifier();
				   if (verif)
					   System.exit(0);
	        }
		});
	}
	
	public void creationMenu() {
		
		creationMenuFichier();
		creationMenuCompilation();
		creationMenuMiniJaja();
		creationMenuJajaCode();
		creationMenuAffichage();
	}
	
	public void creationToolBar() {
		toolBar = new JToolBar();
		bMjj = new JButton("Interpretation Mjj");
		//bMjj.setEnabled(false);
		bComp = new JButton("Compilation");
		//bComp.setEnabled(false);
		bJjc1 = new JButton("Interpretation Jjc Points d'arret");
		bJjc1.setEnabled(false);
		bJjc2 = new JButton("Interpretation Jjc Pas a pas");
		bJjc2.setEnabled(false);
		bCont = new JToggleButton("CT",true);
		bTas = new JToggleButton("DT",true);
		toolBar.add(bMjj);
		interpreterMjj(bMjj);
		toolBar.addSeparator();
		toolBar.add(bComp);
		compilerFichier(bComp);
		toolBar.addSeparator();
		toolBar.add(bJjc1);
		interpreterJjcPtArret(bJjc1);
		toolBar.add(bJjc2);
		interpreterJjcPasAPas(bJjc2);
		toolBar.addSeparator(new Dimension(50,0));
		toolBar.add(bCont);
		toolBar.add(bTas);
		panelGlobal.add(toolBar,BorderLayout.NORTH);
	}
		
	/**
		
		
	}

	private void creationMenuAffichage() {
		// TODO Auto-generated method stub
		
	}

	private void creationMenuMessage() {
		// TODO Auto-generated method stub
		
	}

	private void creationMenuJajaCode() {
		// TODO Auto-generated method stub
		
	}

	private void creationMenuMiniJaja() {
		// TODO Auto-generated method stub
		
	}

	private void creationMenuEdition() {
		// TODO Auto-generated method stub
		
	}*/

	public void creationMenuFichier() {
			
		menuFichier.setMnemonic('F');
		itemNouveau = new JMenuItem("Nouveau");
		itemNouveau.setMnemonic('N');
		menuFichier.add(itemNouveau);
		nouveauFichier();
		itemOuvrir = new JMenuItem("Ouvrir");
		itemOuvrir.setMnemonic('O');
		menuFichier.add(itemOuvrir);
		ouvrirFichier();
		menuFichier.add(new JSeparator());
		itemEnregistrer = new JMenuItem("Enregistrer");
		itemEnregistrer.setMnemonic('E');
		menuFichier.add(itemEnregistrer);
		itemEnregistrer.setEnabled(false);
		enregistrerFichier();
		itemEnregistrerSous = new JMenuItem("Enregistrer sous");
		itemEnregistrerSous.setMnemonic('S');
		menuFichier.add(itemEnregistrerSous);
		itemEnregistrerSous.setEnabled(true);
		enregistrerSousFichier();
		menuFichier.add(new JSeparator());
		itemQuitter = new JMenuItem("Quitter");
		itemQuitter.setMnemonic('Q');
		menuFichier.add(itemQuitter);
		quitterAppli();
		itemQuitter.setEnabled(true);
		menuBar = new JMenuBar();
		menuBar.add(menuFichier);
		this.setJMenuBar(menuBar);
		
	}
	
	public void creationMenuCompilation() {
		menuCompilation.setMnemonic('C');
		itemCompiler = new JMenuItem("Compiler");
		itemCompiler.setMnemonic('O');
		//itemCompiler.setEnabled(false);
		menuCompilation.add(itemCompiler);
		compilerFichier(itemCompiler);
		menuBar.add(menuCompilation);
		this.setJMenuBar(menuBar);
	}
	
	public void creationMenuMiniJaja() {
		menuMjj.setMnemonic('M');
		itemMjj = new JMenuItem("Interpreter Mjj");
		itemMjj.setMnemonic('I');
		//itemMjj.setEnabled(false);
		menuMjj.add(itemMjj);
		interpreterMjj(itemMjj);
		menuBar.add(menuMjj);
		this.setJMenuBar(menuBar);
	}

	public void creationMenuJajaCode() {
		menuJjc.setMnemonic('J');
		itemJjcPasAPas = new JMenuItem("Interpreter Jjc Pas  Pas");
		itemJjcPasAPas.setMnemonic('I');
		itemJjcPasAPas.setEnabled(false);
		menuJjc.add(itemJjcPasAPas);
		interpreterJjcPasAPas(itemJjcPasAPas);
		itemJjcPtArret = new JMenuItem("Interpreter Jjc avec points d'arret");
		itemJjcPtArret.setMnemonic('P');
		itemJjcPtArret.setEnabled(false);
		menuJjc.add(itemJjcPtArret);
		interpreterJjcPtArret(itemJjcPtArret);
		menuBar.add(menuJjc);
		this.setJMenuBar(menuBar);
	}
	
	private void creationMenuAffichage() {
		
		itemFenetreMjj = new JCheckBoxMenuItem("Fenetre Mjj");
		menuAffichage.add(itemFenetreMjj);
		itemFenetreMjj.setEnabled(true);
		itemFenetreMjj.setSelected(true);
		actionFenetreMjj();
		
		itemFenetreJjc = new JCheckBoxMenuItem("Fenetre Jjc");
		menuAffichage.add(itemFenetreJjc);
		itemFenetreJjc.setEnabled(true);
		itemFenetreJjc.setSelected(true);
		actionFenetreJjc();
		
		itemFenetreInterpretation = new JCheckBoxMenuItem("Fenetre Interpretation Mjj");
		menuAffichage.add(itemFenetreInterpretation);
		itemFenetreInterpretation.setEnabled(true);
		itemFenetreInterpretation.setSelected(true);
		actionInterpretation();
		
		
		itemFenetreMessage = new JCheckBoxMenuItem("FenetreMessage");
		menuAffichage.add(itemFenetreMessage);
		itemFenetreMessage.setEnabled(true);
		itemFenetreMessage.setSelected(true);
		actionFenetreMessage();
		
		itemArbreAsa = new JCheckBoxMenuItem("Arbre Asa");
		menuAffichage.add(itemArbreAsa);
		itemArbreAsa.setEnabled(true);
		itemArbreAsa.setSelected(true);
		actionAsa();
		
		menuBar.add(menuAffichage);
		this.setJMenuBar(menuBar);
		
	}
	
	private void enregistrerSousFichier() {
		itemEnregistrerSous.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				enregistrerSous();
			}			
		});
		
	}
	
	public void enregistrerSous() {
		JFileChooser chooser = new JFileChooser(".");
		boolean unsave = true;
        while (unsave) {
        	MyFileFilter filter = new MyFileFilter();         //cration d'un filtre de fichiers
			filter.addExtension("mjj");                       //ajout de l'extension xml au filtre
			filter.setDescription("Code Minijaja");               //description du filtre
			chooser.setFileFilter(filter);
			chooser.setAcceptAllFileFilterUsed(false);        //n'afficher pas le filtre "tout fichier"
			chooser.setSelectedFile(new File("fichier.mjj"));
			int returnVal = chooser.showSaveDialog(panelGlobal);  //ouverture fenetre selection fichier
			if (returnVal == JFileChooser.APPROVE_OPTION) {    //attente appuis touche "enregistrer"
				String fichier = chooser.getSelectedFile().getPath();    //vrification prsence extension .xml et mise en place si non
                int i = fichier.lastIndexOf('.');
                if(i>0 && i<fichier.length()-1) {
                	if (fichier.substring(i+1).equals("mjj") == false)
                		fichier = fichier + ".mjj";
                } else
                    fichier = fichier + ".mjj";

				if (new File(fichier).exists()) { //le fichier existe
					int reponse = JOptionPane.showConfirmDialog(null, "Ce fichier existe deja, voulez-vous le reecrire ?", "Fichier existant", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
    	            if (reponse == JOptionPane.YES_OPTION) {
    	            	int uneerreur = ecritureFichier(fichier);
            			if (uneerreur == 0) {
            				fenMessage.DocMessage.setText("Fichier sauvegarde.");
                			fichierEnregistre = true;
                			nomFichier = new File(fichier).getName();
            				fenMjj.setTitle(nomFichier);
            				fichierSansTitre = false;
            				itemEnregistrer.setEnabled(false);
            				controleType();
            				afficherArbre();
            			} else
        					fenMessage.DocMessage.setText("Fichier non sauvegarde.");
        				unsave = false; //le ficheir a t sauvegard
        			}
				} else {
            		int uneerreur = ecritureFichier(fichier);
            		if (uneerreur == 0) {
            			fenMessage.DocMessage.setText("Fichier sauvegarde.");
            			fichierEnregistre = true;
            			nomFichier = new File(fichier).getName();
        				fenMjj.setTitle(nomFichier);
        				fichierSansTitre = false;
        				itemEnregistrer.setEnabled(false);
        				controleType();
        				afficherArbre();
            		} else
        				fenMessage.DocMessage.setText("Fichier non sauvegarde.");
        			unsave = false;   //on sort de la boucle car le bouton annul a t appuy ou la fenetre de choix a t ferm
				}
			} else 
				unsave = false;
        }
	}
	
	private int ecritureFichier(String leFichier) {
		try {
            FileWriter fw = new FileWriter(leFichier);
            fw.write(fenMjj.getTxtMjj());
            fw.close();
            return 0;
        } catch (FileNotFoundException e) {
                JOptionPane.showMessageDialog(this, "Impossible de creer le fichier.", "Erreur", JOptionPane.INFORMATION_MESSAGE);
                return 1;
        } catch (IOException e) {
                JOptionPane.showMessageDialog(this, "Impossible d'ecrire dans le fichier.", "Erreur", JOptionPane.INFORMATION_MESSAGE);
                return 1;
        }
	}

	private void enregistrerFichier() {
		itemEnregistrer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				enregistrer();
			}
		});		
	}
	
	public void enregistrer() {
		fenMjj.enregistrementFichier();
		fichierEnregistre = true;
		fenMjj.setTitle(nomFichier);
		fichierSansTitre = false;
		itemEnregistrer.setEnabled(false);
		afficherArbre();
	}

	public void ouvrirFichier() { 
		
		itemOuvrir.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JFileChooser boiteOuvertureFichier = new JFileChooser(new File("."));
				if (boiteOuvertureFichier.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
					cheminFichier = boiteOuvertureFichier.getSelectedFile();
					nomFichier = boiteOuvertureFichier.getDescription(cheminFichier);
					fenMjj.ouvertureFichier(cheminFichier, nomFichier);
					fichierEnregistre = true;
					fichierSansTitre = false;
					itemEnregistrer.setEnabled(false);
					controleType();
					afficherArbre();
					fenInterpretation.clear();
				}
			};
		});
		
	}

	public void nouveauFichier() {

		itemNouveau.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (fenMjj.obtenirNomFichier() != "Sans Titre") {
					fenMjj.nouveauFichier();
					fichierEnregistre = true;
					fichierSansTitre = true;
					itemEnregistrer.setEnabled(false);
				}
				fenInterpretation.clear();
			};
		});
		
	}
	
	public void quitterAppli() {

		itemQuitter.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				boolean verif = verifier();
				if (verif)
					System.exit(0);
			};
		});
		
	}
	
	public boolean besoinEnregistrer() {
		if (!fichierSansTitre) {
			enregistrer();
		} else {
			enregistrerSous();
		}
		controleType();
		afficherArbre();
		return parsingOk;
	}
	
	public boolean parsing() {
		
		parsingOk = true;
		
		if (parser == null)
			try {
				parser = new Parser(new FileReader(new File(obtenirCheminFichier())));
			} catch (FileNotFoundException e1) {
				parsingOk = false;
				fenMessage.DocMessage.setText(e1.toString());
			}
		else
			try {
				Parser.ReInit(new FileReader(new File(obtenirCheminFichier())));
			} catch (FileNotFoundException e1) {
				parsingOk = false;
				fenMessage.DocMessage.setText(e1.toString());
			}	
		
		try {
			
			parseTree = parser.analyse();
			
		} catch (ParseException e1) {
			parsingOk = false;
			fenMessage.DocMessage.setText(e1.toString());
		}
				
		return parsingOk;
		
	}
	
	public void controleType() {
		parsingOk = parsing();
		if (bCont.isSelected()) {
			controleDeType = new Controle(parseTree); 
			String stringErreur = controleDeType.stringErreur();
			boolean typage = true;
			if (parsingOk)
			if (controleDeType.noErreur()) {
				typage = true;
				fenMessage.DocMessage.setText("Controle de type Ok!!!");
				parsingOk = typage;
			}
			else {
				typage = false;
				parsingOk = typage;
				fenMessage.DocMessage.setText("Erreur Typage : \n" + stringErreur);
			}
		}
		
	}
	
	public void compilerFichier(javax.swing.AbstractButton item) {
		
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.out.print("COMPILATION");
				
				fenMessage.DocMessage.setText("");
				fenInterpretation.clear();
				
				besoinEnregistrer();				
				
				if (parsingOk) {
						compilateur = new Compilateur(); 
						compilateur.compilation(parseTree);
						fenJjc.afficherJjc(compilateur.toString());
						System.out.print("RES = " + compilateur.toString());
						fenMessage.DocMessage.setText("Compilation Ok!!!");
						jajacode = new InterpreteurJJC(compilateur.getJajacode());
						itemJjcPtArret.setEnabled(true);
						itemJjcPasAPas.setEnabled(true);
						bJjc1.setEnabled(true);
						bJjc2.setEnabled(true);
						
				} else {
					fenMessage.DocMessage.setText("Compilation non effectue!!!");
				}
			
			}			
		});		
	}
	
	public String obtenirCheminFichier() {
		
		return fenMjj.obtenirNomFichier();
	}
	
	public void interpreterMjj(javax.swing.AbstractButton item) {
		
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
					
					boolean executer = true;
					
					fenMessage.DocMessage.setText("");
					
					besoinEnregistrer();
					
					if (parsingOk != false)
					if (minijaja == null) {
					    // On dmarre l'interpretation
						fenMessage.DocMessage.setText("Interprtation MiniJaja Demarre!");
						minijaja = new interpretationMiniJaja(parseTree, stringLigne()); 
					    while (!minijaja.isThreadSuspended()) {  }
					} else {
					    if (minijaja.isAlive()) {
						// On continue l'interpretation
					    	minijaja.resumeThread();
						while (!minijaja.isThreadSuspended() && !minijaja.interpretationTerminee() && minijaja.isAlive()) {}
					    } else {
					    	fenMessage.DocMessage.setText("Interprtation MiniJaja termine!");
						executer = false;
					    }
					}
					
					if (executer) {
					    
					    // On affiche l'tat mmoire
						fenInterpretation.afficherMjj("" + minijaja.getEtatMemoire().stringStack());
						if (bTas.isSelected())
							fenInterpretation.afficherTasMjj(minijaja.getEtatMemoire().displayTas2());
						//minijaja.getEtatMemoire().showStack();

					    // Ainsi que le numro de ligne interprt
						fenMessage.DocMessage.setText("Interprtation de la ligne " + minijaja.getLigneEnCours());					    					    
					}			
			}
		});	
		
	}
	
	public void interpreterJjcPtArret(javax.swing.AbstractButton item) {
		
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int ret;
				fenMessage.DocMessage.setText("Debut de l'interpretation JJC avec Points d'arrets.");
				Vector vPtArret = fenJjc.getPointsArret();
				ret = jajacode.interpretation(vPtArret);
				if (ret == -1) {
					fenMessage.DocMessage.setText("Fin interpretation JJC.");
				} else {
					if (ret == -2) {						
						fenMessage.DocMessage.setText("Erreur interpretation JJC : Division par 0.");
					} else {
						fenMessage.DocMessage.setText("Point d'arret JJC ligne : " + (ret+1));
					}
				}
				fenInterpretation.afficherJjc(jajacode.getMemoire().stringStack());
				if (bTas.isSelected())
					fenInterpretation.afficherTasJjc(jajacode.getMemoire().displayTas2());
			}
		});		
	}

	public void interpreterJjcPasAPas(javax.swing.AbstractButton item) {
		
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int ret;
				fenMessage.DocMessage.setText("Interpretation Pas a Pas : ligne " + (jajacode.getIndice()+1));
				ret = jajacode.interpretationPasAPas();
				System.out.println("ind="+ret);
				if (ret == -1) {
					fenMessage.DocMessage.setText("Fin interpretation JJC.");
				} else {
					if (ret == -2) {						
						fenMessage.DocMessage.setText("Erreur interpretation JJC : Division par 0.");
					} else {
						
					}
				}
				//jajacode.getMemoire().showStack();
				fenInterpretation.afficherJjc(jajacode.getMemoire().stringStack());
				if (bTas.isSelected())
					fenInterpretation.afficherTasJjc(jajacode.getMemoire().displayTas2());
				
				
			}


		});
		
	}
	
	private void actionFenetreMjj() {		
		itemFenetreMjj.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Object source = e.getSource();
				if (itemFenetreMjj.isSelected())
					fenMjj.setVisible(true);
				else
					fenMjj.setVisible(false);				
			}
		});
	}
	
	private void actionFenetreJjc() {		
		itemFenetreJjc.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Object source = e.getSource();
				if (itemFenetreJjc.isSelected())
					fenJjc.setVisible(true);
				else
					fenJjc.setVisible(false);				
			}
		});
	}
	
	private void actionInterpretation() {		
		itemFenetreInterpretation.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Object source = e.getSource();
				if (itemFenetreInterpretation.isSelected())
					fenInterpretation.setVisible(true);
				else
					fenInterpretation.setVisible(false);
			}
		});
	}
	
	private void actionAsa() {		
		itemArbreAsa.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Object source = e.getSource();
				if (itemArbreAsa.isSelected()) {
					fenAsa.setVisible(true);
					try {
						fenAsa.setSelected(true);
					} catch (PropertyVetoException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
				else
					fenAsa.setVisible(false);
			}
		});
	}
		
	private void actionFenetreMessage() {		
		itemFenetreMessage.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Object source = e.getSource();
				if (itemFenetreMessage.isSelected())
					fenMessage.setVisible(true);
				else
					fenMessage.setVisible(false);
			}
		});
	}
	
	public void afficherArbre() {
		try {
			fenAsa.AfficheArbre(createArbre());
			fenAsa.repaint();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public JTree createArbre() throws FileNotFoundException, ParseException {
		TreeNode root = makeSampleTree();
		JTree tree = new JTree(new DefaultTreeModel(root));
	
		return tree;	
	}
	
	public TreeNode makeSampleTree() throws FileNotFoundException, ParseException {
		
		String nameBranche="Arbre";
		String message = "";
		DefaultMutableTreeNode root = new DefaultMutableTreeNode(nameBranche);
		try{
			if (parser == null)
				parser = new Parser(new FileReader(obtenirCheminFichier()));
			else
				Parser.ReInit(new FileReader(obtenirCheminFichier()));
		
			parseTree = parser.analyse();
			parseTree.dump1("",root);
		}
		catch(FileNotFoundException e1){
			message += e1.toString();
		}
		catch(ParseException e2){
			message += e2.toString();
		}
		return root;
	}

	
	public String stringLigne() {
		
		String res = "";
		int nbLigne = fenMjj.getNombreLigne();
		for (int i = 1 ; i <=  nbLigne ; i++) {
			res += i;
			if (i != nbLigne)
				res +=",";
		}
		
		return (res);
		
	}
	
	
	public boolean verifier() {
		boolean res = true;
		if (!fichierEnregistre) {
			int reponse = JOptionPane.showConfirmDialog(null, "Voulez-vous sauvegarder les modifications avant de quitter ?", "Sauvegarde avant fermeture", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
			if (reponse == JOptionPane.CANCEL_OPTION) {
				res = false;
			} else {
				if (reponse == JOptionPane.YES_OPTION) {
					if (!fichierSansTitre)
						enregistrer();
					else
						enregistrerSous();
				}
			}
		}
		return res;
	}
	
	
}
